/* ########## 4.5 Margin ########## */

@mixin margin-variant($num, $viewport:"") {

   @if $viewport=="" {
      $viewport: "-";
   }

   @else {
      $viewport: "-"+ $viewport + "-";
   }

   //ie. .u-mrgn-sm-0
   //ie. .u-mrgn-sm-0
   .u-mrgn#{$viewport}-#{$num} {
      margin: #{$num}px !important;
   }

   //ie. .u-mrgn-sm-y-0
   .u-mrgn#{$viewport}v--#{$num} {
      margin-top: #{$num}px !important;
      margin-bottom: #{$num}px !important;
   }

   //ie. .u-mrgn-sm-x-0
   .u-mrgn#{$viewport}h--#{$num} {
      margin-left: #{$num}px !important;
      margin-right: #{$num}px !important;
   }

   //ie. .u-mrgn-sm-t-0
   .u-mrgn#{$viewport}top--#{$num} {
      margin-top: #{$num}px !important;
   }

   .u-mrgn#{$viewport}right--#{$num} {
      margin-right: #{$num}px !important;
   }

   .u-mrgn#{$viewport}bottom--#{$num} {
      margin-bottom: #{$num}px !important;
   }

   .u-mrgn#{$viewport}left--#{$num} {
      margin-left: #{$num}px !important;
   }
}

@mixin do-margin-variant($viewport) {
   $num: 0;

   @while $num < 100 {
      @include margin-variant($num, $viewport);
      $num: $num + 5;
   }

   //margin: 10x to 100px with step of 5px
   $num: 10;

   @while $num <=100 {
      @include margin-variant($num, $viewport);
      $num: $num + 5;
   }
}


//margin: 0px to 9px
$num: 0;

@while $num < 100 {
   @include margin-variant($num);
   $num: $num + 5;
}

//margin: 10x to 100px with step of 5px
$num: 10;

@while $num <=120 {
   @include margin-variant($num);
   $num: $num + 5;
}

.u-mrgn-top--auto {
   margin-top: auto;
}

.u-mrgn-right--auto {
   margin-right: auto;
}

.u-mrgn-bottom--auto {
   margin-bottom: auto;
}

.u-mrgn-left--auto {
   margin-left: auto;
}

.u-mrgn-h--auto {
   margin: auto;
}

.u-mrgn-h--neg-10 {
   margin-left: -10px;
   margin-right: -10px;
}

.u-mrgn-h--neg-20 {
   margin-left: -20px;
   margin-right: -20px;
}

@mixin margin-breakpoint($viewport) {

   .u-mrgn-#{$viewport}-top-auto {
      margin-top: auto;
   }

   .u-mrgn-#{$viewport}-right--auto {
      margin-right: auto;
   }

   .u-mrgn-#{$viewport}-bottom--auto {
      margin-bottom: auto;
   }

   .u-mrgn-#{$viewport}-left--auto {
      margin-left: auto;
   }

   .u-mrgn-#{$viewport}--auto {
      margin: auto;
   }

   .u-mrgn-#{$viewport}-h--auto {
      margin-left: auto;
      margin-right: auto;
   }

}

@media (min-width: 480px) {
   @include do-margin-variant("xs");
   @include margin-breakpoint("xs");
}

@include media-breakpoint-up(sm) {
   @include do-margin-variant("sm");
   @include margin-breakpoint("sm");
}

@include media-breakpoint-up(md) {
   @include do-margin-variant("md");
   @include margin-breakpoint("md");
}

@include media-breakpoint-up(lg) {
   @include do-margin-variant("lg");
   @include margin-breakpoint("lg");
}

@include media-breakpoint-up(xl) {
   @include do-margin-variant("xl");
   @include margin-breakpoint("xl");
}


.u-mrgn-right--2 {
   margin-right: 2px !important;
}
.u-mrgn-right--3 {
   margin-right: 3px !important;
}


.u-mrgn-top--145 {
   margin-top: 145px !important;
}
.u-mrgn-top--165 {
   margin-top: 165px !important;
}
.u-mrgn-top--170 {
   margin-top: 170px !important;
}
.u-mrgn-top--195 {
   margin-top: 195px !important;
}
.u-mrgn-top--200 {
   margin-top: 200px !important;
}

.u-top--neg-40 {
   top: -40px!important;
}